<template>
    <div>
        <h1 class="mb-6">Clients -> Add New Client</h1>

        <div class="max-w-lg mx-auto">
            <div class="alert-danger">
                <ul v-if="errors.length">
                    <li v-for="error in errors" :key="error">{{ error }}</li>
                </ul>
            </div>
            <div class="form-group">
                <label for="name">Name</label>
                <input
                    type="text"
                    id="name"
                    class="form-control"
                    v-model="client.name"
                />
            </div>
            <div class="form-group">
                <label for="email">Email</label>
                <input
                    type="text"
                    id="email"
                    class="form-control"
                    v-model="client.email"
                />
            </div>
            <div class="form-group">
                <label for="phone">Phone</label>
                <input
                    type="text"
                    id="phone"
                    class="form-control"
                    v-model="client.phone"
                />
            </div>
            <div class="form-group">
                <label for="name">Address</label>
                <input
                    type="text"
                    id="address"
                    class="form-control"
                    v-model="client.address"
                />
            </div>
            <div class="flex">
                <div class="form-group flex-1">
                    <label for="city">City</label>
                    <input
                        type="text"
                        id="city"
                        class="form-control"
                        v-model="client.city"
                    />
                </div>
                <div class="form-group flex-1">
                    <label for="postcode">Postcode</label>
                    <input
                        type="text"
                        id="postcode"
                        class="form-control"
                        v-model="client.postcode"
                    />
                </div>
            </div>

            <div class="text-right">
                <a href="/clients" class="btn btn-default">Cancel</a>
                <button @click="storeClient" class="btn btn-primary">
                    Create
                </button>
            </div>
        </div>
    </div>
</template>

<script>
import axios from 'axios';

export default {
    name: 'ClientForm',

    data() {
        return {
            client: {
                name: '',
                email: '',
                phone: '',
                address: '',
                city: '',
                postcode: '',
            },
            errors: [],
        };
    },

    methods: {
        storeClient() {
            axios
                .post('/clients', this.client)
                .then((data) => {
                    window.location.href = data.data.url;
                })
                .catch((error) => {
                    if (error.response.status === 422) {
                        this.errors = Object.values(
                            error.response.data.errors
                        ).flat();
                    } else {
                        this.errors = 'Something went wrong.';
                    }
                });
        },
    },
};
</script>
